#!/bin/bash
# Simple shell script to test HW problems with fixed inputs
# Run this in your HW directory by doing
# lila [ckauffm2-hw1]% ./hw1-test.sh

failed=0
passed=0
tests=0

# Problem 1 tests
tests=$((tests+2))

if [ ! -e p1.c ]; then
    echo MISSING: p1.c 
    failed=$((failed+1))
else
    echo Compiling p1.c
    rm -f p1 p1.exe
    gcc -o p1 p1.c -lm
    if (( $? )); then
	echo Failed to compile p1.c
	failed=$((failed+1))
    else 
	echo

	TEST='P1 Test 1'
	echo $TEST
	INPUT="1.2 8 -23.87"
	EXPECTED='Roots at x = 2.23.* and x = -8.90.*'
	OUTPUT=`echo $INPUT | ./p1 | sed -n '$p'`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo

	TEST='P1 Test 2'
	echo $TEST
	INPUT="-4.2 9.9 -32.32"
	EXPECTED='Discriminant < 0: the roots are imaginary'
	OUTPUT=`echo $INPUT | ./p1 | sed -n '$p'`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
    fi
fi
echo

# Problem 2 tests
tests=$((tests+2))

if [ ! -e p2.c ]; then
    echo MISSING: p2.c 
    failed=$((failed+1))
else
    echo Compiling p2.c
    rm -f p2 p2.exe
    gcc -o p2 p2.c -lm
    if (( $? )); then
	echo Failed to compile p2.c
	failed=$((failed+1))
    else 
	echo

	TEST='P2 Test 1'
	echo $TEST
	INPUT='5.5 2.3'
  	EXPECTED='2 2 2 2.000000 2.391304 2.173913'
	OUTPUT=`echo $INPUT | ./p2 | sed -n '$p'`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo

	TEST='P2 Test 2'
	echo $TEST
	INPUT="42.1 -14.2"
	EXPECTED='-3 -2 -2 -3.000000 -2.964789 -2.957746'
	OUTPUT=`echo $INPUT | ./p2 | sed -n '$p'`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
    fi
fi
echo 

# Problem 3 tests
tests=$((tests+4))

if [ ! -e p3.c ]; then
    echo MISSING: p3.c 
    failures=$((failures+1))
else
    echo Compiling p3.c
    rm -f p3 p3.exe
    gcc -o p3 p3.c -lm
    if (( $? )); then
	echo Failed to compile p3.c
	failures=$((failures+1))
    else 
	echo

	TEST='P3 Test 1'
	echo $TEST
	INPUT='17'
  	EXPECTED='0 dollar coins 0 quarters 1 dimes 1 nickels 2 pennies'
	OUTPUT=`echo $INPUT | ./p3 | tr '\n' ' '`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failures=$((failures+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo

	TEST='P3 Test 2'
	echo $TEST
	INPUT='24'
  	EXPECTED='0 dollar coins 0 quarters 2 dimes 0 nickels 4 pennies'
	OUTPUT=`echo $INPUT | ./p3 | tr '\n' ' '`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failures=$((failures+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
        echo

	TEST='P3 Test 3'
	echo $TEST
	INPUT='19'
  	EXPECTED='0 dollar coins 0 quarters 1 dimes 1 nickels 4 pennies'
	OUTPUT=`echo $INPUT | ./p3 | tr '\n' ' '`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failures=$((failures+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo

	TEST='P3 Test 4'
	echo $TEST
	INPUT='243'
  	EXPECTED='2 dollar coins 1 quarters 1 dimes 1 nickels 3 pennies'
	OUTPUT=`echo $INPUT | ./p3 | tr '\n' ' '`
	echo $OUTPUT | grep -q -e "$EXPECTED"
	if (( $? )); then
	    echo FAILED
	    printf "input: $INPUT\npattern: $EXPECTED\noutput: $OUTPUT\n" \
		"$INPUT" "$PATTERN" "$OUTPUT"
	    failures=$((failures+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi

    fi
fi
echo


# Problem 4 tests
tests=$((tests+4))

if [ ! -e p4.c ]; then
    echo MISSING: p4.c 
    failed=$((failed+1))
else
    echo Compiling p4.c
    rm -f p4 p4.exe
    gcc -o p4 p4.c -lm
    if (( $? )); then
	echo Failed to compile p4.c
	failed=$((failed+1))
    else 
	echo

	TEST='P4 Test 1'
	echo $TEST
	INPUT='100 20 250'
	cat > EXPECTED <<\EOF	# Escape to prevent $ from being interpretted
2000.0
297
$2010000.00
$74250.00
$202000.00
$-127750.00
-15
EOF
	echo $INPUT | ./p4 | awk 'NR > 2{print $NF}'  > OUTPUT
	cmp EXPECTED OUTPUT
	if (( $? )); then
	    echo FAILED
	    printf 'input: %s\nexpected:\n%s\noutput:\n%s\n' \
		"$INPUT" "`cat EXPECTED`" "`cat OUTPUT`"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo

	TEST='P4 Test 2'
	echo $TEST
	INPUT='200 7.5 500'
	cat > EXPECTED <<\EOF	# Escape to prevent $ from being interpretted
1500.0
198
$1510000.00
$99000.00
$152000.00
$-53000.00
-28
EOF
	echo $INPUT | ./p4 | awk 'NR > 2{print $NF}'  > OUTPUT
	cmp EXPECTED OUTPUT
	if (( $? )); then
	    echo FAILED
	    printf 'input: %s\nexpected:\n%s\noutput:\n%s\n' \
		"$INPUT" "`cat EXPECTED`" "`cat OUTPUT`"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo


	TEST='P4 Test 3'
	echo $TEST
	INPUT='13 11.5 800'
	cat > EXPECTED <<\EOF	# Escape to prevent $ from being interpretted
149.5
20
$159500.00
$16000.00
$16950.00
$-950.00
-167
EOF
	echo $INPUT | ./p4 | awk 'NR > 2{print $NF}'  > OUTPUT
	cmp EXPECTED OUTPUT
	if (( $? )); then
	    echo FAILED
	    printf 'input: %s\nexpected:\n%s\noutput:\n%s\n' \
		"$INPUT" "`cat EXPECTED`" "`cat OUTPUT`"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo
	

	TEST='P4 Test 4'
	echo $TEST
	INPUT='12 11.5 800'
	cat > EXPECTED <<\EOF	# Escape to prevent $ from being interpretted
138.0
20
$148000.00
$16000.00
$15800.00
$200.00
740
EOF
	echo $INPUT | ./p4 | awk 'NR > 2{print $NF}'  > OUTPUT
	cmp EXPECTED OUTPUT
	if (( $? )); then
	    echo FAILED
	    printf 'input: %s\nexpected:\n%s\noutput:\n%s\n' \
		"$INPUT" "`cat EXPECTED`" "`cat OUTPUT`"
	    failed=$((failed+1))
	else
	    echo Passed
	    passed=$((passed+1))
	fi
	echo
	
    fi
fi
echo


echo ------------------
echo Failures: $failed

if (( $failed == 0 )); then
    echo All tests passed
fi

percent=$(bc -l <<< "$passed / $tests * 50")
printf 'Tests Passed: %d / %d = %.2f / 50\n' $passed $tests $percent

